PVPZonePlates = CreateFrame("Frame")

local PVPZonePlates_quiet = 0

function PVPZonePlates:OnEvent(event, arg1, ...)
	if event == "ADDON_LOADED" and arg1 == "PVPZonePlates" then
		PVPZonePlates:UnregisterEvent("ADDON_LOADED")
		PVPZonePlates:RegisterEvent("PLAYER_ENTERING_WORLD")
		PVPZonePlates:RegisterEvent("UPDATE_WORLD_STATES")
		PVPZonePlates:RegisterEvent("ZONE_CHANGED_NEW_AREA")
		return
	end
	PVPZonePlates:UpdatePlates()
end

function PVPZonePlates:UpdatePlates()
	local pvpzone = PVPZonePlates:InPvpZone()
	if not PVPZonePlates_quiet then
		print("|cff23e523You have just entered a PVP ZONE; Nameplates are now enabled.|r")
	end
	if pvpzone == 1 then
		SetCVar("nameplateShowEnemies", 1)
		else
		SetCVar("nameplateShowEnemies", 0)
	end
end

function PVPZonePlates:InPvpZone()
	local pvptype = GetZonePVPInfo()
	if pvptype == "arena" or pvptype == "combat" then
		return 1
	end
	local _, instancetype = IsInInstance()
	if instancetype == "pvp" then
		return 1
	end
end

PVPZonePlates:SetScript("OnEvent", PVPZonePlates.OnEvent)
PVPZonePlates:RegisterEvent("ADDON_LOADED")
